package com.example.kevin.embeddedsystemsprojecti;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.support.v4.app.DialogFragment;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.math.BigInteger;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketException;
import java.net.UnknownHostException;
import java.nio.ByteOrder;
import java.nio.CharBuffer;
import java.util.Enumeration;
import java.lang.Math;
import java.lang.*;
import java.util.Formatter;

public class MainActivity extends AppCompatActivity {

    SeekBar hghtsk,tltsk;
    TextView stat,set;
    //ServerSocket serverSocket;
    Server server;
    int height = 0;
    int tilt = 0;
    int crntheight = 0;
    int crnttilt = 0;
    int prvheight = 0;
    int prvtilt = 0;
    boolean auto = false;
    String cdOut = "";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        stat = (TextView) findViewById(R.id.txt1);
        set = (TextView) findViewById(R.id.txt2);

        server = new Server(this);


        hghtsk = (SeekBar) findViewById(R.id.hghtsk);
        hghtsk.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            //int prog = 0;
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                height = progress;
                set.setText("Set:\n\t\tHeight: "+height+"\n\t\tTilt: "+tilt);
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {
            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {
                set.setText("Set:\n\t\tHeight: "+height+"\n\t\tTilt: "+tilt);
            }
        });

        tltsk = (SeekBar) findViewById(R.id.tltsk);
        tltsk.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                tilt = progress - 10;
                set.setText("Set:\n\t\tHeight: "+height+"\n\t\tTilt: "+tilt);
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {
            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {
                set.setText("Set:\n\t\tHeight: "+height+"\n\t\tTilt: "+tilt);
            }
        });

        final Button setbutt = (Button) findViewById(R.id.setbutt);
        setbutt.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                prvheight = crntheight;
                prvtilt = crnttilt;
                crntheight = height;
                crnttilt = tilt;
                stat.setText("Status:\n\t\tTime: "+cdOut+"\n\t\tHeight: "+crntheight+"\n\t\tTilt: "+crnttilt+"\n");
            }
        });

        final Button autbutt = (Button) findViewById(R.id.autbutt);
        autbutt.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                /*if(server.){
                    Toast.makeText(getApplicationContext(),"Thread Started",Toast.LENGTH_SHORT).show();
                }*/
            }
        });

        final Button ipbutt = (Button) findViewById(R.id.ipbutt);
        ipbutt.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                DialogFragment dialog = MyDialogFragment.newInstance(server.getIpAddress(),""+server.getPort());
                dialog.show(getSupportFragmentManager(),"MyDialogFragmentTag");
                /*if(serverSocket != null){
                    DialogFragment dialog = MyDialogFragment.newInstance(getIpAddress(),""+serverSocket.getLocalPort());
                    dialog.show(getSupportFragmentManager(),"MyDialogFragmentTag");
                    //Toast.makeText(getApplicationContext(),"IP: "+getIpAddress(),Toast.LENGTH_SHORT).show();
                }
                else{
                    Toast.makeText(getApplicationContext(),"Server Port Access Denied",Toast.LENGTH_SHORT).show();
                }*/
            }
        });
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        server.onDestroy();
    }


    public static class MyDialogFragment extends DialogFragment {
        public static MyDialogFragment newInstance(String ip, String port){
            MyDialogFragment frag = new MyDialogFragment();
            Bundle args = new Bundle();
            args.putString("ip",ip);
            args.putString("port",port);
            frag.setArguments(args);
            return frag;
        }
        @Override
        public Dialog onCreateDialog(Bundle savedInstanceState){
            AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
            builder.setTitle("Server Information");
            builder.setMessage("IP: "+getArguments().getString("ip")+"\nPort: "+getArguments().getString("port"));
            builder.setPositiveButton("OK", new DialogInterface.OnClickListener(){
                public void onClick(DialogInterface dialog, int id){
                }
            });
            return builder.create();
        }
    }

    public class Server {
        MainActivity activity;
        ServerSocket serverSocket;
        String message = "";
        static final int socketServerPORT = 8080;

        public Server(MainActivity activity) {
            this.activity = activity;
            Thread socketServerThread = new Thread(new SocketServerThread());
            socketServerThread.start();
        }

        public int getPort() {
            return socketServerPORT;
        }

        public void onDestroy() {
            if (serverSocket != null) {
                try {
                    serverSocket.close();
                } catch (IOException e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                }
            }
        }

        private class SocketServerThread extends Thread {

            int count = 0;

            @Override
            public void run() {
                try {
                    // create ServerSocket using specified port
                    serverSocket = new ServerSocket(socketServerPORT);

                    while (true) {
                        // block the call until connection is created and return
                        //Socket object
                        Socket socket = serverSocket.accept();
                        count++;
                        message += "#" + count + " from "
                                + socket.getInetAddress() + ":"
                                + socket.getPort() + "\n";

                        activity.runOnUiThread(new Runnable() {
                            @Override
                            public void run() {
                                //activity.msg.setText(message);
                                //Toast.makeText(getApplicationContext(),message,Toast.LENGTH_LONG).show();
                            }
                        });

                        SocketServerReplyThread socketServerReplyThread =
                                new SocketServerReplyThread(socket, count);
                        socketServerReplyThread.run();

                    }
                } catch (IOException e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                }
            }
        }

        private class SocketServerReplyThread extends Thread {

            private Socket hostThreadSocket;
            int cnt;

            SocketServerReplyThread(Socket socket, int c) {
                hostThreadSocket = socket;
                cnt = c;
            }

            @Override
            public void run() {
                OutputStream outputStream;
                String msgReply = getCodeOut();
                //Toast.makeText(getApplicationContext(),msgReply,Toast.LENGTH_SHORT).show();

                try {
                    outputStream = hostThreadSocket.getOutputStream();
                    PrintStream printStream = new PrintStream(outputStream);
                    printStream.print(msgReply);
                    printStream.close();

                    message += "replayed: " + msgReply + "\n";

                    activity.runOnUiThread(new Runnable() {

                        @Override
                        public void run() {
                            //activity.msg.setText(message);
                        }
                    });

                } catch (IOException e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                    message += "Something wrong! " + e.toString() + "\n";
                }

                activity.runOnUiThread(new Runnable() {

                    @Override
                    public void run() {
                        //activity.msg.setText(message);
                    }
                });
            }

        }

        public String getIpAddress() {
            String ip = "";
            try {
                Enumeration<NetworkInterface> enumNetworkInterfaces = NetworkInterface
                        .getNetworkInterfaces();
                while (enumNetworkInterfaces.hasMoreElements()) {
                    NetworkInterface networkInterface = enumNetworkInterfaces
                            .nextElement();
                    Enumeration<InetAddress> enumInetAddress = networkInterface
                            .getInetAddresses();
                    while (enumInetAddress.hasMoreElements()) {
                        InetAddress inetAddress = enumInetAddress
                                .nextElement();

                        if (inetAddress.isSiteLocalAddress()) {
                            ip += "Server running at : "
                                    + inetAddress.getHostAddress();
                        }
                    }
                }

            } catch (SocketException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
                ip += "Something Wrong! " + e.toString() + "\n";
            }
            return ip;
        }
    }

    public String getCodeOut(){
        String out = "";
        if((crntheight==0)&&(crnttilt==0)){
            out = ("00000"); //send signal for resettozero()
        }
        else if((crntheight == 0)&&(crnttilt == -10)){
            out = ("10000"); //send signal for closetiltup()
        }
        else if((crntheight == 0)&&(crnttilt == 10)){
            out = ("20000"); //send signal for closetiltdown()
        }
        else if((crntheight == 0)&&(crntheight != prvheight)){
            out = ("50000"); //send signal for fulldown()
            prvheight = crntheight;
        }
        else if((crntheight == 10)&&(crntheight != prvheight)){
            out = ("40000"); //send signal for fullup()
            prvheight = crntheight;
        }
        else if (crntheight != prvheight){
            //out = ("60-10"); //send signal for moveto()
            prvheight = crntheight;
            if(crntheight==10) {
                out = "600" + crntheight;
            }
            else{
                out = "6000" + crntheight;
            }
        }
        else// if((crnttilt != prvtilt))
        {
            //out = ("30"+ ((String) crnttilt)); //send signal for tiltto()
            prvtilt = crnttilt;
            if(crnttilt>=0){
                out = "300";
            }
            else{
                out = "30-";
            }

            if(Math.abs(crnttilt)==10){
                out = out+Math.abs(crnttilt);
            }
            else{
                out = out+"0"+Math.abs(crnttilt);
            }
        }
        //Toast.makeText(getApplicationContext(),out,Toast.LENGTH_SHORT).show();
        cdOut = out;
        return out;
    }
}
